/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.io.Serializable;
import java.util.Comparator;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.dao.MCodeDao;
import jp.mosp.system.dto.MCodeDto;
import jp.mosp.system.vo.HolidayMasterListVo;

public class HolidayMasterListAction extends MosPAction {

	// コマンド
	private static final String CMD_HOLIDAY_MASTER_LIST_SHOW      = "S2710";	// 表示
	private static final String CMD_HOLIDAY_MASTER_LIST_SELECT    = "S2711";	// 検索
	private static final String CMD_HOLIDAY_MASTER_LIST_RE_SEARCH = "S2712";	// 再検索
	private static final String CMD_HOLIDAY_MASTER_LIST_SORT      = "S2713";	// ソート

	/**
	 * コンストラクタ
	 */
	public HolidayMasterListAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得
		HolidayMasterListVo vo;
		Object obj = session.getAttribute(MospConst.ATT_FORMER_VO);
		if (obj instanceof HolidayMasterListVo) {
			vo = (HolidayMasterListVo)obj;
			vo.clearMessage();
			vo.clearErrField();
		} else {
			vo = new HolidayMasterListVo();
		}		
		vo.clearMessage();
		vo.clearErrField();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		session.setAttribute(MospConst.ATT_FORMER_VO, vo);
		// コマンド毎の処理		
		if (cmd.equals(CMD_HOLIDAY_MASTER_LIST_SHOW)) {
			// 検索履歴を初期値にセット
			vo.setSearchmode(HolidayMasterListVo.SEARCH_OFF);
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_LIST_SELECT)) {
			// 検索処理
			vo.setParams(request);
			searchHolidayList(vo);
			vo.setIsAscending(true);
			vo.initListInfo();
			// 検索履歴をありにセット
			vo.setSearchmode(HolidayMasterListVo.SEARCH_ON);
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_LIST_RE_SEARCH)) {
			// 再検索
			if(vo.getSearchmode() == HolidayMasterListVo.SEARCH_ON){
				session.removeAttribute(MospConst.ATT_DTO);
				searchHolidayList(vo);
				vo.setPageButton();
				sortList(vo);
			}
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_LIST_SORT)) {
			// ソート
			sortList(key1, vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 休日リスト検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	private void searchHolidayList(HolidayMasterListVo vo) throws Exception {
		// 検索
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setFields(dao.findForHoliday(CommonConst.NAM_HOLIDAY, vo.getTxtHDate(), vo.getTxtHName()));
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryHDate().length == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}

	/**
	 * ソート
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(String key, HolidayMasterListVo vo) throws MospException {
		vo.sortList(key, getComparator(key, vo));
		vo.setFields(vo.getList());
	}

	/**
	 * ソート(VO内のキー情報でソート)
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(HolidayMasterListVo vo) throws MospException {
		vo.sortList(getComparator(vo.getFormerKey(), vo));
		vo.setFields(vo.getList());
	}

	/**
	 * 比較クラス取得
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private Comparator getComparator(String key, HolidayMasterListVo vo) throws MospException {
		Comparator comp = null;
		if (key.equals(vo.KEY_H_CODE)) {
			comp = new CompHCode();
		} else if (key.equals(vo.KEY_H_NAME)) {
			comp = new CompHName();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}

	/**
	 * コードによる比較クラス
	 */
	protected static class CompHCode implements Comparator, Serializable {
		private static final long serialVersionUID = -5324184931004173732L;
		public int compare(Object obj1, Object obj2) {
			MCodeDto dto1 = (MCodeDto)obj1;
			MCodeDto dto2 = (MCodeDto)obj2;
			return dto1.getTCode().compareTo(dto2.getTCode());
		}
	}

	/**
	 * コード名称による比較クラス
	 */
	protected static class CompHName implements Comparator, Serializable {
		private static final long serialVersionUID = -3122154963469415094L;
		public int compare(Object obj1, Object obj2) {
			MCodeDto dto1 = (MCodeDto)obj1;
			MCodeDto dto2 = (MCodeDto)obj2;
			return dto1.getTName().compareTo(dto2.getTName());
		}
	}

}
